<?php
class ModelExtensionTotalDiscountOnShipping extends Model {
	public function getTotal($total) {	

		if (isset($this->session->data['shipping_method']) && isset($this->session->data['payment_method'])) {			

			$shipping_code = explode('.', $this->session->data['shipping_method']['code']);
			$code = $shipping_code[0];
			
			$discount_value = $this->config->get('total_discount_on_shipping_'.$code);	
			
			if ( !empty($discount_value) && (int)$discount_value > 0 ){

				$andlogic = $this->config->get('total_discount_on_shipping_'.$code.'_andlogic');
				$payment = $this->config->get('total_discount_on_shipping_'.$code.'_payment');
				$title = $this->config->get('total_discount_on_shipping_'.$code.'_discountName');
			
			    if ($andlogic == 0) {				
					$this->DoDiscountCalculation($total, $discount_value, $title);
				} 
				
				if ($andlogic == 1) {				
					if ($this->session->data['payment_method']['code'] == $payment) {
						$this->DoDiscountCalculation($total, $discount_value, $title);
					}
				}
				
				if ($andlogic == 2) {			
					if ($this->session->data['payment_method']['code'] != $payment) {
						$this->DoDiscountCalculation($total, $discount_value, $title);
					}
				}				
			}
		}
	}
	
	private function DoDiscountCalculation($total, $discount, $title) {
					
		$value = ($total['total'] / 100) * $discount;

		$total['totals'][] = array(
				'code'       => 'discount_on_shipping',
				'title'      => $title,
				'value'      => $value, //$discount,
				'sort_order' => $this->config->get('total_discount_on_shipping_sort_order')
			);
		
		$total['total'] -= $value;
	}
}